Share via


Discovery Solution - List

Lists the relevant Azure Diagnostics, Solutions and Troubleshooters using problemClassification API) AND resourceUri or resourceType.
Discovery Solutions is the initial entry point within Help API, which identifies relevant Azure diagnostics and solutions.

Required Input : problemClassificationId (Use the problemClassification API)
Optional input: resourceUri OR resource Type

Note: ‘requiredInputs’ from Discovery solutions response must be passed via ‘additionalParameters’ as an input to Diagnostics and Solutions API.

GET https://management.azure.com/providers/Microsoft.Help/discoverySolutions?api-version=2024-03-01-preview
GET https://management.azure.com/providers/Microsoft.Help/discoverySolutions?api-version=2024-03-01-preview&$filter={$filter}&$skiptoken={$skiptoken}

URI Parameters

Name In Required Type Description
api-version
query True

string

minLength: 1

The API version to use for this operation.

$filter
query

string

'ProblemClassificationId' is a mandatory filter to get solutions ids. It also supports optional 'ResourceType' and 'SolutionType' filters. The $filter supports only 'and', 'or' and 'eq' operators. Example: $filter=ProblemClassificationId eq '1ddda5b4-cf6c-4d4f-91ad-bc38ab0e811e'

$skiptoken
query

string

Skiptoken is only used if a previous operation returned a partial result.

Responses

Name Type Description
200 OK

DiscoveryResponse

The request has succeeded.

Other Status Codes

ErrorResponse

An unexpected error response.

Security

azure_auth

Azure Active Directory OAuth2 Flow.

Type: oauth2
Flow: implicit
Authorization URL: https://login.microsoftonline.com/common/oauth2/authorize

Scopes

Name Description
user_impersonation impersonate your user account

Examples

List DiscoverySolutions at resource scope

Sample request

GET https://management.azure.com/providers/Microsoft.Help/discoverySolutions?api-version=2024-03-01-preview&$filter=ProblemClassificationId eq 'SampleProblemClassificationId1'

Sample response

{
  "value": [
    {
      "name": "SampleProblemClassificationId1",
      "type": "Microsoft.Help/discoverySolutions",
      "id": "/providers/microsoft.help/discoverySolutions/SampleProblemClassificationId1",
      "properties": {
        "solutions": [
          {
            "description": "This is an azure solution to troubleshoot subscription issues.",
            "requiredInputs": [
              "SubscriptionId"
            ],
            "solutionId": "SampleSolutionId1",
            "solutionType": "Diagnostics"
          }
        ]
      }
    }
  ]
}

Definitions

Name Description
createdByType

The type of identity that created the resource.

DiscoveryResponse

Discovery response.

ErrorAdditionalInfo

The resource management error additional info.

ErrorDetail

The error detail.

ErrorResponse

Error response

SolutionMetadataProperties

Metadata Properties

SolutionMetadataResource

Metadata resource

SolutionType

Solution Type.

systemData

Metadata pertaining to creation and last modification of the resource.

createdByType

The type of identity that created the resource.

Value Description
User
Application
ManagedIdentity
Key

DiscoveryResponse

Discovery response.

Name Type Description
nextLink

string (uri)

The link to the next page of items

value

SolutionMetadataResource[]

The SolutionMetadataResource items on this page

ErrorAdditionalInfo

The resource management error additional info.

Name Type Description
info

object

The additional info.

type

string

The additional info type.

ErrorDetail

The error detail.

Name Type Description
additionalInfo

ErrorAdditionalInfo[]

The error additional info.

code

string

The error code.

details

ErrorDetail[]

The error details.

message

string

The error message.

target

string

The error target.

ErrorResponse

Error response

Name Type Description
error

ErrorDetail

The error object.

SolutionMetadataProperties

Metadata Properties

Name Type Description
description

string

A detailed description of solution.

requiredInputs

string[]

Required parameters for invoking this particular solution.

solutionId

string

Solution Id.

solutionType

SolutionType

Solution Type.

SolutionMetadataResource

Metadata resource

Name Type Description
id

string (arm-id)

Fully qualified resource ID for the resource. E.g. "/subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/providers/{resourceProviderNamespace}/{resourceType}/{resourceName}"

name

string

The name of the resource

properties.solutions

SolutionMetadataProperties[]

List of metadata.

systemData

systemData

Azure Resource Manager metadata containing createdBy and modifiedBy information.

type

string

The type of the resource. E.g. "Microsoft.Compute/virtualMachines" or "Microsoft.Storage/storageAccounts"

SolutionType

Solution Type.

Value Description
Diagnostics

Diagnostics resource type.

Solutions

Solutions resource type.

Troubleshooters

Troubleshooters resource type.

SelfHelp

SelfHelp resource type.

systemData

Metadata pertaining to creation and last modification of the resource.

Name Type Description
createdAt

string (date-time)

The timestamp of resource creation (UTC).

createdBy

string

The identity that created the resource.

createdByType

createdByType

The type of identity that created the resource.

lastModifiedAt

string (date-time)

The timestamp of resource last modification (UTC)

lastModifiedBy

string

The identity that last modified the resource.

lastModifiedByType

createdByType

The type of identity that last modified the resource.